// AlphaImageWrapper.cpp: implementation of the AlphaImageWrapper class.
//
//////////////////////////////////////////////////////////////////////

//#include <windows.h>
#include <stdlib.h>
#include <stdio.h>
#include <GL/gl.h>
#include "AlphaImageWrapper.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

extern unsigned char *loadJPG(char *path,int *width,int *height);

AlphaImageWrapper::AlphaImageWrapper()
{

}

AlphaImageWrapper::~AlphaImageWrapper()
{

}

// Set OpenGL texture from jpeg
static int UploadAlphaJPEG(char *alpha,char *image)
{
    int x,y;
    unsigned char *pixels,*alffa;

    pixels=loadJPG(image,&x,&y);
    if(pixels==NULL)
        return(-1);

    alffa=loadJPG(alpha,&x,&y);
    if(pixels==NULL)
        return(-1);

    unsigned char *img=new unsigned char[x*y*4];

    // Add alpha to image
    for(int a=0;a<y;a++)
        for(int b=0;b<x;b++)
        {
            img[a*4*x+b*4]=pixels[a*3*x+b*3];
            img[a*4*x+b*4+1]=pixels[a*3*x+b*3+1];
            img[a*4*x+b*4+2]=pixels[a*3*x+b*3+2];
            img[a*4*x+b*4+3]=alffa[a*3*x+b*3];
        }

    // The picture is loaded. Now dump it to GL.
    GLuint   lumero;
    glGenTextures(1,&lumero);
    glBindTexture(GL_TEXTURE_2D,lumero);
    glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_WRAP_S,GL_REPEAT);
    glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_WRAP_T,GL_REPEAT);

    glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_NEAREST);
    glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_NEAREST);

    glTexImage2D(GL_TEXTURE_2D,0,GL_RGBA,x,y,0,GL_RGBA,GL_UNSIGNED_BYTE,img);

    delete(pixels);
    delete(img);
    delete(alffa);

    return(lumero);
}

AlphaImageWrapper::AlphaImageWrapper(char *alpha, char *image)
{
	int i=UploadAlphaJPEG(alpha, image);

	texture_id=i;
	//if (i<0) { MessageBox(NULL, image, "Error loading", MB_OK); texture_id=0; }
	if (i<0) { fprintf(stderr,"Error loading\n"); texture_id=0; }
}
