// MP3Player.cpp: implementation of the MP3Player class.
//
//////////////////////////////////////////////////////////////////////

#include <stdio.h>
#include <stdlib.h>
#include "main.h"
#include "MP3Player.h"


//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

MP3Player::MP3Player(char *path)
{
	if (!FSOUND_Init(44100, 32, 0))
	{
		char temp[255];
		fprintf(stderr, "%s\n", FMOD_ErrorString(FSOUND_GetError()));
		exit(EXIT_FAILURE);
	}

	/** load stream into memory ;) **/
	FILE *	fp;
	int		length;
	char *	data;

	fp = fopen(path, "rb");
	if (!fp)
	{
		char temp[255];
		fprintf(stderr, "File not found %s\n", path);
		FSOUND_Close();
		exit(EXIT_FAILURE);
	}
	fseek(fp, 0, SEEK_END);
	length = ftell(fp);
	fseek(fp, 0, SEEK_SET);

	data = (char *)malloc(length);
	fread(data, length, 1, fp);
	fclose(fp);

	stream = FSOUND_Stream_OpenFile(data, FSOUND_NORMAL | FSOUND_LOOP_NORMAL | FSOUND_LOADMEMORY, length);
}

MP3Player::~MP3Player()
{
	FSOUND_Stream_Close(stream);
	FSOUND_Close();
}

void MP3Player::Play()
{
	if ((channel = FSOUND_Stream_Play(FSOUND_FREE, stream)) == -1)
	{
		char temp[255];
		fprintf(stderr, "%s\n", FMOD_ErrorString(FSOUND_GetError()));

		FSOUND_Close();
		exit(EXIT_FAILURE);
	}

//	FSOUND_SetPriority(channel, 255);
	FSOUND_SetPan(channel, FSOUND_STEREOPAN);
}
