/*
    The main function for Yuri Nation. Uses GLUT for opening the screen.

    - Marq 2001
*/

#include <GL/glut.h>
#include <GL/glu.h>
#include <GL/gl.h>

#include <stdlib.h>
#include <sys/time.h>
#include <sys/types.h>
#include <unistd.h>
#include <stdio.h>

int WIDTH=640,HEIGHT=480,init=0;

extern void Frame(unsigned long TIME);
extern char Init();
extern void Deinit();

void piirra(void);  //  Draw callback
void akti(void);    //  Idle callback
void nappi(unsigned char b,int x,int y);    //  Keyboard callback
void shaappi(int w,int h);  // Reshape callback

long currentTime(void); //  Returns milliseconds from the beginning

int main(int argc,char *argv[])
{
    //  Initialize GLUT
    glutInit(&argc,argv);
    glutInitDisplayMode(GLUT_DOUBLE|GLUT_RGBA|GLUT_DEPTH);
    glutInitWindowSize(WIDTH,HEIGHT);

// New GLUT (>=3.7) has fullscreen, older ones don't
#ifndef OLDGLUT
    glutCreateWindow("Yuri Nation by NAN5");

    if(argc>=2)
        if(!strcmp(argv[1],"-f"))
            glutFullScreen();
#else
    glutCreateWindow("Yuri Nation by NAN5");
#endif

    glutSetCursor(GLUT_CURSOR_NONE);
    glutDisplayFunc(piirra);
    glutIdleFunc(akti);
    glutKeyboardFunc(nappi);

    //  Initialize GL
    glEnable(GL_TEXTURE_2D);
    WIDTH=glutGet((GLenum)GLUT_SCREEN_WIDTH);
    HEIGHT=glutGet((GLenum)GLUT_SCREEN_HEIGHT);
    glViewport(0,0,WIDTH,HEIGHT);
    glMatrixMode(GL_PROJECTION);
    glLoadIdentity();
    gluPerspective(45.0f,(float)(WIDTH/HEIGHT),0.1f,10000.0f);
    glMatrixMode(GL_MODELVIEW);
    glLoadIdentity();
    glClearColor(0, 0, 0, 0);

    //Init();
    glutMainLoop();
}

void piirra(void)
{
    //  Call the mainloop and swap screens
    if(!init++)
         Init();
    else
    	Frame(currentTime());

    //  If demo ended let's quit
    if(currentTime()>(60*2+12)*1000)
    {
        Deinit();
        exit(EXIT_SUCCESS);
    }

    glutSwapBuffers();
}

void akti(void)
{
    glutPostRedisplay();
}

void shaappi(int w,int h)
{
    glViewport(0,0,w,h);
    WIDTH=w;
    HEIGHT=h;
}

void nappi(unsigned char b,int x,int y)
{
    if(b==27) // If ESC pressed then exit
    {
        Deinit();
        exit(EXIT_SUCCESS);
    }
}

long currentTime(void)
{
    double  aeka,alku;

    static long    alux=0,aluxu=0;

    struct timeval  system_time;
    struct timezone system_timezone;

    // Get the exact timer value
    gettimeofday(&system_time,&system_timezone);
    if(!alux)
    {
        alux=system_time.tv_sec;
        aluxu=system_time.tv_usec;
    }
    alku=(double)alux*1000.0+(double)aluxu/1000.0;

    // Convert timer value to milliseconds
    aeka=1000.0*system_time.tv_sec+system_time.tv_usec/1000.0;
    aeka-=alku;

    return(long(aeka));
}

/* EOS */
